/*
  version:1.9
  time: 2019-2-25
*/

(function(root) {

  var infoBeatCj = function() { //构造函数  函数对象
    return new infoBeatCj.prototype.init();
  }
  var BURIED_MARK_ATTR_NAME = 'BURIED_MARK';  // 埋点标记，dom属性名

  if (typeof Object.assign != 'function') {
    Object.assign = function(target) {
      'use strict';
      if (target == null) {
        throw new TypeError('Cannot convert undefined or null to object');
      }

      target = Object(target);
      for (var index = 1; index < arguments.length; index++) {
        var source = arguments[index];
        if (source != null) {
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
      }
      return target;
    };
  }

  infoBeatCj.fn = infoBeatCj.prototype = { //原型对象
    length: 0,
    opt: {},
    infoBeatInputsArr: [],
    buriedArr: [],
    pageUrl: '',
    init: function() {
      return this;
    },
    initForApp: function(opt) {
        if (typeof opt == 'string') {
            opt = JSON.parse(opt)
        }

        this.opt = Object.assign(this.opt, opt);
    },

    bindCollectionEvent: function (objs) {


      var arr = [];
      var bpArr = []
      var pageUrl = window.location.href
      console.log('传入埋点列表', objs)
      if(objs instanceof Array) {
        arr = objs
      } else if (typeof objs == 'string') {
        arr = JSON.parse(objs);
      }


      for (var i =0; i< arr.length; i++) {
         if (pageUrl.indexOf(arr[i].wPageUrl) > -1) {

           bpArr.push(arr[i])
         }
      }

      if (bpArr.length) {

        console.log('当前页的埋点', bpArr)
        this.pageUrl = bpArr[0].wPageUrl;// 取任意一个wPageUrl为当前url
        this.bindEvent(bpArr)
      }
    },

    bindEvent: function(arr) {
      var _this = this;
      var triggleEventHandler = function (ev) {
        var el = ev.target || ev.srcElement
        // 判断属于埋点则上报，否则事件向上冒泡
        if (!!el.getAttribute(BURIED_MARK_ATTR_NAME)) {
          // if(event.stopPropagation){
          //   ev.stopPropagation();
          // } else {
          //   ev.cancelBubble = true;
          // }
          _this.datacj(ev.target || ev.srcElement, _this.pageUrl)
        }
      }

      arr.forEach(function (item) {
        var doms = _this.getDomByXPath(item.wUnique)
        if (doms && doms.length) {


          doms.forEach(function (dom) {
            // 没有埋点标记的DOM则进行埋点
            if (!dom.getAttribute(BURIED_MARK_ATTR_NAME)) {


              dom.setAttribute(BURIED_MARK_ATTR_NAME, item.wUnique)
              // 绑定埋点点击事件
              _this.addEvent(dom, 'click', triggleEventHandler)

              // 绑定埋点子节点点击事件
              if (dom.children.length) {
                _this.addChildDomEvent(dom, 'click', triggleEventHandler);
              }
            }
          })
        }
      })
    },

    addChildDomEvent: function(dom, type, handler) {
      var _this = this;
      var childDoms = Array.prototype.slice(dom.children);

      childDoms.forEach(function (item) {
        var itemChildDoms = item.children;
        if (itemChildDoms.length) _this.addChildDomEvent(item, handler)
        else if (item.getAttribute(BURIED_MARK_ATTR_NAME)) _this.addEvent(item, type, handler) // 给非埋点绑定事件
      })
    },

    getDomByXPath: function(xpath) {
      try {
        var xresult = document.evaluate(xpath, document, null, XPathResult.ANY_TYPE, null);
        var xnodes = [];
        var xres;
        while (xres = xresult.iterateNext()) {
          xnodes.push(xres);
        }

        return xnodes;
      } catch (e) {
        return [];
      }
    },

    addEvent: function() {
      function fixEvent(event) {
        if (event) {
          event.preventDefault = fixEvent.preventDefault;
          event.stopPropagation = fixEvent.stopPropagation;
          event._getPath = fixEvent._getPath;
        }
        return event;
      }
      fixEvent._getPath = function() {
        var ev = this;
        var polyfill = function() {
          try {
            var element = ev.target;
            var pathArr = [element];
            if (element === null || element.parentElement === null) {
              return [];
            }
            while (element.parentElement !== null) {
              element = element.parentElement;
              pathArr.unshift(element);
            }
            return pathArr;
          } catch (err) {
            return [];
          }
        };
        return this.path || (this.composedPath && this.composedPath()) || polyfill();
      };
      fixEvent.preventDefault = function() {
        this.returnValue = false;
      };
      fixEvent.stopPropagation = function() {
        this.cancelBubble = true;
      };

      var register_event = function(element, type, handler) {
        var useCapture = true; // 埋点需要事件冒泡

        if (element && element.addEventListener) {
          var hdl =  function(e) {
            e._getPath = fixEvent._getPath;
            handler.call(this, e);
          }
          // 绑定事件前先移除事件，避免多次绑定
          element.removeEventListener(type, hdl)
          element.addEventListener(type, hdl, useCapture);
        } else {
          var ontype = 'on' + type;
          var old_handler = element[ontype];
          element[ontype] = makeHandler(element, handler, old_handler);
        }
      };

      function makeHandler(element, new_handler, old_handlers) {
        var handler = function(event) {
          event = event || fixEvent(window.event);
          if (!event) {
            return undefined;
          }
          event.target = event.srcElement;

          var ret = true;
          var old_result, new_result;
          if (typeof old_handlers === 'function') {
            old_result = old_handlers(event);
          }
          new_result = new_handler.call(element, event);
          if ((false === old_result) || (false === new_result)) {
            ret = false;
          }
          return ret;
        };
        return handler;
      }

      register_event.apply(null, arguments);
    },
    events: function() {
      root.first = true;
      var _this = this;

      // this.addEvent(document, 'click', function (e) {
      //   var ev = e;
      //   if (!ev) {
      //     return false;
      //   }
      //   var target = ev.target || ev.srcElement;
      //   if (typeof target !== 'object') {
      //     return false;
      //   }
      //   if (typeof target.tagName !== 'string') {
      //     return false;
      //   }
      //   var tagName = target.tagName.toLowerCase();
      //   if (tagName.toLowerCase() === 'body' || tagName.toLowerCase() === 'html') {
      //     return false;
      //   }
      //   if (!target || !target.parentNode || !target.parentNode.children) {
      //     return false;
      //   }
      //
      //   // 采集对象
      //   _this.datacj(target)
      // })
    },

    readXPath: function(element) {
      if (element.id !== "") {//判断id属性，如果这个元素有id，则显 示//*[@id="xPath"]  形式内容
        return "//*[@id='"+ element.id +"']";
      }
      //这里需要需要主要字符串转译问题，可参考js 动态生成html时字符串和变量转译（注意引号的作用）
      if (element == document.body) {//递归到body处，结束递归
        return '/html/' + element.tagName.toLowerCase();
      }

      var ix = 1,//在nodelist中的位置，且每次点击初始化
        siblings = element.parentNode.children;//同级的子元素

      for (var i = 0, l = siblings.length; i < l; i++) {
        var sibling = siblings[i];
        //如果这个元素是siblings数组中的元素，则执行递归操作
        if (sibling == element) {
          return arguments.callee(element.parentNode) + '/' + element.tagName.toLowerCase() + '[' + (ix) + ']';
          //如果不符合，判断是否是element元素，并且是否是相同元素，如果是相同的就开始累加
        } else if (sibling.nodeType == 1 && sibling.tagName == element.tagName) {
          ix++;
        }
      }
    },
    getElementViewLeft: function(element) {
      var actualLeft = element.offsetLeft;
      var current = element.offsetParent;
      return actualLeft
    },
    getElementPosition: function(e) {
      var x = 0, y = 0;
      while (e != null) {
        x += e.offsetLeft;
        y += e.offsetTop;
        e = e.offsetParent;
      }
      return { x: x, y: y };
    },
    getScrollOffsets: function(w) {
      var w = w || window;
      if (w.pageXoffset != null) {
        return { x: w.pageXoffset, y: pageYoffset };
      }
      var d = w.document;
      if (document.compatMode == "CSS1Compat") // 标准兼容模式开启
        return { x: d.documentElement.scrollLeft, y: d.documentElement.scrollTop };
      return { x: d.body.scrollLeft, y: d.body.scrollTop };
    },
    getElementViewTop: function(element) {
      var actualTop = element.offsetTop;
      var current = element.offsetParent;
      return actualTop
    },
    submitCIForApp: function(str) {
      var ua = navigator.userAgent.toLowerCase()
      if (ua.indexOf("android") != -1) { // android
          window.java.getWebInfo(str)
      } else if (ua.indexOf("iphone") != -1) {
          if (this.opt.iosBrowserFrame == 'UIWebview') { // ios旧版框架
              window.IBCollectJsFunc(str)
          } else if (this.opt.iosBrowserFrame == 'WkWebview') { // ios新版框架
              window.webkit.messageHandlers.IBCollectJsFunc.postMessage(str);
          }
      }
    },
    _getScrollLeft: function(dom) {
        if (dom && (dom.nodeName != 'BODY' || dom.nodeName != 'HTML')) {
            if (transform != 'none') {
                var transform = window.getComputedStyle(dom).transform
                if (!transform) return 0;
                var sl = parseFloat(transform.replace(/[^0-9\-,]/g, '').split(',')[4])
                if (!isNaN(sl))
                    return -sl; // 负值转正
                else
                    return 0;

            } else {
                return this._getScrollLeft(dom.parentElement)
            }
        } else {
            return 0;
        }
    },
    //搜集相关信息并传递给客户端
    datacj: function(dom, pageUrl) {
      var obj = {};
      var dom0 = dom ;
      var width = dom0.clientWidth || dom0.offsetWidth;
      var height = dom0.clientHeight || dom0.offsetHeight;
      var position = this.getElementPosition(dom0)
      var left = position.x
      var top = position.y
      var texts = dom0.innerText;
      // var scroll = this.getScrollOffsets().y;
      var scroll = window.pageXoffset || document.body.scrollTop || document.documentElement.scrollTop || 0;
      var widths = window.screen.width;
      var heights = window.screen.height
      var nodeName = dom0.nodeName ? dom0.nodeName.toLowerCase() : "";
      var scrollLeft = this._getScrollLeft(dom0);
      var x = left - scrollLeft;              // 考虑左右滚动条情况减去左边滚动值得到x坐标
      var y = dom0.getBoundingClientRect().top;  // 直接获取元素y坐标

      obj.wUnique = this.readXPath(dom0)
      obj.wName = dom0.nodeName ? dom0.nodeName.toLowerCase() : "";
      obj.wFrame = left + "," + top + "," + width + "," + height + "," + scroll + "," + widths + "," + heights + "," + x + "," + y;
      obj.wId = (obj.wUnique + pageUrl).replace(/'|"/g, '');
      obj.clickType = '-1';
      obj.wUrl = '';
      obj.wPageUrl = pageUrl;

      switch(nodeName) {
        case "button":
          obj.wEvenType = 1;
          break;
        case "input":
          obj.wEvenType = 3;
          break;
        case "a":
          obj.wEvenType = 4;
          obj.wUrl = dom0.getAttribute("href")
          break;
        case "img":
          obj.wEvenType = 5;
          break;
        case "audio":
          obj.wEvenType = 6;
          break;
        case "video":
          obj.wEvenType = 7;
          break;
        default:
          obj.wEvenType = 8;
      }
      obj.wText = obj.wEvenType == 3 ? dom0.value.replace(/[\r\n]/g, "") :  obj.wEvenType == 5 ? dom0.getAttribute("src") : texts.replace(/[\r\n]/g, "");

      var str = JSON.stringify([obj]);
      console.log('采集埋点信息', str)

      // if (navigator.userAgent.toLowerCase().indexOf("android") != -1) {
      //   root.java.getWebInfo(str)
      // } else if (navigator.userAgent.toLowerCase().indexOf("iphone") != -1) {
      //   root.WebViewJavascriptMTSSBridge.callHandler('WXGZGetWID', str)
      // }
      this.submitCIForApp(str)
    },
  }

  // if(navigator.userAgent.toLowerCase().indexOf("iphone") != -1) {
  //   //iOS通信网桥方法
  //   root.setupWebViewJavascriptMTSSBridge = function(callback) {
  //     if(root.WebViewJavascriptMTSSBridge) {
  //       return callback(root.WebViewJavascriptMTSSBridge);
  //     }
  //     if(root.WVJBCallbacks) {
  //       return root.WVJBCallbacks.push(callback);
  //     }
  //     root.WVJBCallbacks = [callback];
  //     var WVJBIframe = document.createElement('iframe');
  //     WVJBIframe.style.display = 'none';
  //     WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
  //     document.documentElement.appendChild(WVJBIframe);
  //     setTimeout(function() {
  //       document.documentElement.removeChild(WVJBIframe)
  //     }, 0)
  //   }
  //   root.setupWebViewJavascriptMTSSBridge(function(bridge) {
  //     root.WebViewJavascriptMTSSBridge = bridge;
  //   })
  // }

  infoBeatCj.fn.init.prototype = infoBeatCj.fn;
  root.infoBeatCj = infoBeatCj;

  if(!root.first) {
    infoBeatCj().events();
  }
})(window);
